﻿//***** build a menu on mouse right-click ***********************************************************************************
procedure Form1_OnShow (Sender: string; Action: string);
var
  PopupMenu: TPopupMenu;
  MyItem: TMenuItem;
begin
  PopupMenu := TPopupMenu.Create(Form1);

  MyItem := TMenuItem.Create (PopupMenu);
  MyItem.Caption := 'Add';
  MyItem.OnClick := @MenuClick1;
  PopupMenu.Items.Add(MyItem);

  MyItem := TMenuItem.Create (PopupMenu);
  MyItem.Caption := 'Edit';
  MyItem.OnClick := @MenuClick2;
  PopupMenu.Items.Add(MyItem);

  MyItem := TMenuItem.Create (PopupMenu);
  MyItem.Caption := 'Delete';
  MyItem.OnClick := @MenuClick3;
  PopupMenu.Items.Add(MyItem);
                                                                
  MyItem := TMenuItem.Create (PopupMenu);
  MyItem.Caption := 'Find';
  MyItem.OnClick := @MenuClick4;
  PopupMenu.Items.Add(MyItem);

  MyItem := TMenuItem.Create (PopupMenu);
  MyItem.Caption := 'Show on Map';
  MyItem.OnClick := @MenuClick5;
  PopupMenu.Items.Add(MyItem);

  Form1.tablegrid1.PopupMenu := PopupMenu;  //** replace standard right-click actions with bespoke actions
  form1.tablegrid1.SelectedRow := 0;  //** place the cursor in the first row of the table
  Form1.TableGrid1.Columns[0].Footer.color := $000080FF;  //** color the footer total
  Form1.TableGrid1.Columns[8].Visible := False;
end;

procedure MenuClick1 (Sender: string);
begin
  form1.button1.click;
end;
procedure MenuClick2 (Sender: string);
begin
  form1.button5.click;
end;
procedure MenuClick3 (Sender: string);
begin
  form1.button3.click;
end;
procedure MenuClick4 (Sender: string);
begin
  form1.edit9.visible := true;
  form1.button6.visible := true;
  form1.edit9.setfocus;
end;
procedure MenuClick5 (Sender: string);
begin
  form1.button7.click;
end;

//***** place cursor in the first edit field ****************************************************************************
procedure Form2_OnShow (Sender: string; Action: string);
begin
  form2.edit8.setfocus;
end;

//***** add colour to the footer total ***********************************************************************************
procedure Form1_TableGrid1_OnChange (Sender: string);
  var
    i,c: integer;
  begin
    c := form1.tablegrid1.RowCount - 1;  // conditional cell formatting (missing documents)
      for i := 0 to c do
        begin
          if form1.tablegrid1.Cells[8,i] <> '' then
            begin
              form1.tablegrid1.Cell[0,i].Color := $00ABC59E;
              form1.tablegrid1.Cell[1,i].Color := $00ABC59E;
            end;
        end;
  Form1.TableGrid1.Columns[8].Visible := False;         
  Form1.TableGrid1.Columns[0].Footer.color := $000080FF;
end;

//***** close the 'find' field and reset *********************************************************************************
procedure Form1_Button6_OnClick (Sender: string; var Cancel: boolean);
begin
  form1.edit9.clear;
  form1.edit9.visible := false;
  form1.button6.Visible := false;
end;

//***** get rid of spaces in the postcode so that googlemaps works properly **********************************************
procedure Form2_Edit4_OnChange (Sender: string);
begin
  form2.edit9.text := ReplaceStr(form2.edit4.text,' ','');
end;

//***** put the person and the address you're fetching in google maps and put it on the form caption *********************
procedure map_OnShow (Sender: string; Action: string);
begin
  map.caption := sqlexecute('select postcode||":  "||fname||" "||lname||", "||street||", "||town||", "||phone from people where id =' +inttostr(form1.tablegrid1.dbitemid));
  map.button7.click;
end;

//***** call google maps and pass the postcode through as a parameter to build the address *******************************
procedure map_Button1_OnClick (Sender,v1,v2: string; var Cancel: boolean);
begin
  v1 := 'https://www.google.com/maps/?q=' ;
  v2 := sqlexecute('select postcode from people where id = ' + inttostr(form1.tablegrid1.dbitemid));
  openurl(v1+v2);
end;

procedure map_Button7_OnClick (Sender: string; var Cancel: boolean);
var
  vurl: string;
  vaddress: string;
begin
  vaddress := sqlexecute('select pcnospaces from people where id =' +inttostr(form1.tablegrid1.dbitemid));
  vurl := 'https://maps.googleapis.com/maps/api/staticmap?center='+vaddress+'&zoom=17&markers=color:red%7Clabel:C%7C'+vaddress+'&size=640x440&maptype=hybrid';
  HTTPGetFile(vurl, 'googlemaps.png');
  map.Image1.Picture.LoadFromFile('googlemaps.png');
end;

begin
end.


